Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.Runtime.InteropServices
Module Module1
    ' Lawson Labs, Inc.
    ' 3239 Phoenixville Pike
    ' Malvern, PA  19355
    ' 800 321-5355 or 406 257-5355
    ' World Wide Web - www.lawsonlabs.com
    ' Last modified: 11-13-00
    ' file executable: VB201NET.exe
    ' requires NT_m203.DLL version 10,19,2012,0 or newer
    Public fScanning As Byte
    <Runtime.InteropServices.StructLayout(Runtime.InteropServices.LayoutKind.Sequential, Pack:=4)> _
 Structure M203
        Dim comPort As Short ' Currently selected comm port (0 to 3) for COM1 .. COM4
        Dim scanInterval As Double ' Current scan interval in seconds
        Dim numChannels As Short ' Number of scanning channels (always 1 for Model 203)
        Dim tScan As Short ' Scan type (always 0 for Model 203)
        Dim scanChan As Short ' Current scan mode channel (0,1,6, or 7)
        Dim lastDigInp As Short ' Last digital input value
        Dim version As Short ' Model 203 version (203)
        Dim pollChan As Short ' Current polled mode channel
        Dim subSample As Short ' Number of subsamples per conversion 160 for 60HZ, 192 for 50 Hz
        Dim rawCount As Integer ' Last raw count returned from Model 203
        Dim digOutWord As Integer ' Last value sent to Model 203 for digital output (0-255)
        Dim wordCnt As Short ' number of bytes in a conversion result (2 = 16-bit, 3 = 24-bit)
        Dim errorType As Integer ' error code returned from DLL
        Dim bU As Integer ' BiPolar UniPolar Input Range (Not Used on Model 203)
        'UPGRADE_NOTE: filter was upgraded to filter_Renamed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
        Dim filter_Renamed As Short ' Input filter selection (not used on Model 203)
        Dim divideBy As Short ' Remote (power of 2) division (0 to 7)
        Dim gain As Double ' Last calculated Gain
        Dim maxRate As Single ' Maximum sample rate (120 Hz for 60Hz, 100 Hz for 50Hz)
        Dim totalPeriods As Short ' (modeRegLo) - Number of conversions per sample
        Dim modeRegLo As Short '
        Dim modeRegMid As Short ' MSB = Word Length, always 1 (24 bit), remaining bits unused
        Dim modeRegHi As Short ' Mode Register High - Unused on Model 203
        Dim baud As Short ' BAUD rate code (0-5) 0=9600 bps ... 5=300 bps
        Dim dac1volts As Single ' Current Voltage for Analog Output 1
        Dim dac2volts As Single ' Current Voltage for Analog Output 2
        Dim dacEnable As Short ' Not Used (DACs always enabled)
        Dim timeBase As Integer ' must be a positive value
        Dim echoTestCount As Integer ' Serial Echo Test Byte Count
        Dim offsetTotal As Integer ' Last calculated Offset
        Dim runningAvg As Integer ' Running Average
        Dim dataAcqMode As Short ' 0 = Scanning, 1 = Polled
        Dim inputBuffer As Integer ' receive queue sizes for Windows COMM driver
        Dim wL As Short ' Word Length - Always 128 for 24-bit with M203
        Dim gain1 As Single ' Last calculated Gain
        Dim totalBits As Double ' Total possible bits of resolution
        Dim scan As Byte
        Dim scan1 As Byte
        Dim scan2 As Byte
        Dim retry As Integer ' Number of SignOn retrys
        Dim ChanChgFlg As Short
        Dim Voltage As Double
    End Structure


    Public theThread As Threading.Thread '10-15-12 new
    Public threadRun As Boolean '10-15-12 new
    Public curChan As Byte

    Public fInvalidChanChange As Boolean
    Public fDebugFile As Byte
    Public fSignedOn As Boolean

    Public DigInToken As Integer
    Public DacToSet As Integer

    Public placeholder As Integer
    Public reserved As Integer
    Public spare As Integer

    'following 4 variables for graphic display handling only
    Public scandisp As Byte
    Public posfs As Integer
    Public negfs As Integer
    Public vdiv As Integer
    Public hdiv As Integer

    Public CountArray(100) As Double 'Running voltage average array
    Public ArrayPointer As Short 'Running voltage average array pointer
    Public CountTotal As Double 'Running voltage average array total
    Public ChanChgFlg As Short 'Channel Change Flag, 1 = Channel has been changed

    Public GetConversionInitialized As Boolean
    Public frmat As String

    Public EchoTestFlg As Short
    Public NewScanBuff(300) As Byte 'buffer for passing one scan from DLL
    Public BuffDebugMsg(255) As Byte 'buffer for passing debug text from DLL to app

    Public cc(6) As Short 'control code workspace
    Public M_203 As M203 'm203 structured data shared with DLL

    Public structPnt As IntPtr  '10-18-12

    Public CfgFileSpec As String 'Config file name
    Public localAvg As Short 'Averaging done in host
    Public IdComDev As Integer 'Handle to Com-port (not for use in this code)
    Public retVal As Short 'return value for DLL functions
    Public WaitTime As Double 'filter settling time in seconds
    Public Msg As String 'message string
    Public fStopScan As Boolean 'flag to stop scanning
    'NT_m203.DLL external functions
    'UPGRADE_WARNING: Structure M203 may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    '10-18-12 Declare Function SetPtrs Lib "NT_m203.dll" (ByRef T_M203 As M203, ByRef NewScanBuff As Byte, ByRef BuffDebugMsg As Byte) As Short
    'Declare Function SetPtrs Lib "NT_m203.dll" (ByRef T_M203 As M203, ByRef NewScanBuff As Byte, ByRef BuffDebugMsg As Byte) As Short
    Declare Function SetPtrs Lib "NT_m203.dll" (ByVal structPnt As IntPtr, ByRef NewScanBuff As Byte, ByRef BuffDebugMsg As Byte) As Short

    '10-18-12
    Declare Function GetStructPtr Lib "NT_m203.dll" () As IntPtr



    Declare Function ChangeAnalogOutput Lib "NT_m203.dll" (ByVal DacToSet As Short) As Short
    Declare Function ClearVoltageArray Lib "NT_m203.dll" () As Short

    'this group of functions corresponds exactly to commands described in
    'the programmmer's reference section of your manual
    Declare Function GetDigIn Lib "NT_m203.dll" (ByVal DigInToken As Short) As Short
    Declare Function SetDigOut Lib "NT_m203.dll" () As Short
    Declare Function GetVer Lib "NT_m203.dll" () As Short
    Declare Function GetConversion Lib "NT_m203.dll" () As Short
    Declare Function SetChanCode Lib "NT_m203.dll" () As Short
    Declare Function GetCheckSum Lib "NT_m203.dll" () As Short

    'establish communications with Model 201 and send all set-up information
    'Declare Function SignOn Lib "NT_m203.dll" (ByRef EchoTestFlg As Short, ByVal fDebug As Byte) As Short
    'Declare Function SignOn Lib "NT_m203.dll" (ByRef T_M203 As M203, ByRef EchoTestFlg As Short, ByVal fDebug As Byte) As Short
    Declare Function SignOn Lib "NT_m203.dll" (ByRef EchoTestFlg As Short, ByVal fDebug As Byte) As Short

    'select chan 7, wait, & do offset cal. Select chan 6, wait & do full scale cal.
    Declare Function SysCal Lib "NT_m203.dll" () As Short

    'starts type of scan determined by sType
    'ScanToken=0x8B; Edge=0; for normal scan
    Declare Function StartScanning Lib "NT_m203.dll" (ByVal ScanToken As Integer, ByVal Edge As Integer) As Short

    Declare Function StopScanning Lib "NT_m203.dll" () As Short

    'fetch one scan, wait scantime first, if one isn't ready. Used usually to
    ' empty buffer at end of scanning
    Declare Function GetOneScan Lib "NT_m203.dll" () As Short

    '5-25-06 following two functions added to similate Model 201
    Declare Function GetNumScansInBuffer Lib "NT_m203.dll" () As Integer
    Declare Sub Gconv Lib "NT_m203.dll" ()


    'Declare Function CheckScanTime Lib "NT_m203.dll" (ByRef NewScanInterval As Double, _
    '            ByRef MaxTime As Double, ByRef MinTime As Double) As Integer
    Declare Function CheckScanTime Lib "NT_m203.dll" (ByRef NewScanInterval As Double, _
                ByRef MaxTime As Double, ByRef MinTime As Double) As Short

    'remove "size" bytes from serial input buffer(normally used for end-of-scan _
    'framing token only)
    'Declare Sub RemFromBuffer Lib "NT_m203.dll" (ByVal size As Long)

    'Declare Function SendADMode Lib "NT_m203.dll" () As Integer
    Declare Function SendADMode Lib "NT_m203.dll" () As Short '10-10-12
    'Declare Function FullScaleCal Lib "NT_m203.dll" () As Integer
    'Declare Function OffsetCal Lib "NT_m203.dll" () As Integer

    'Windows API external functions
    Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Integer, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Integer) As Integer
    Declare Function GetModuleHandle Lib "kernel32" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Integer
    Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Integer) As Integer
    Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

    '  Configuration file should be created and tested using the C or
    '  Quick Basic driver software. Note that there are various values
    '   in the configuration file that aren't used by the 203. They are
    '   defined as "Placeholder" in the following file read.
    Public Sub ReadCfgFile()
        Dim cf As Integer
        Dim sStr As String
        If Right(My.Application.Info.DirectoryPath, 1) = "\" Then
            CfgFileSpec = My.Application.Info.DirectoryPath & "M203.cfg"
        Else
            CfgFileSpec = My.Application.Info.DirectoryPath & "\M203.cfg"
        End If

        cf = FreeFile()
        On Error GoTo NO_FILE
        FileOpen(cf, CfgFileSpec, OpenMode.Input)

        ' (6 parameters) Configuration file Line 1
        Input(cf, sStr)
        M_203.modeRegHi = Val(sStr)
        Input(cf, sStr)
        M_203.modeRegMid = Val(sStr)
        Input(cf, sStr)
        M_203.modeRegLo = Val(sStr)
        Input(cf, sStr)
        M_203.pollChan = Val(sStr)
        Input(cf, sStr)
        M_203.subSample = Val(sStr)
        sStr = LineInput(cf)
        M_203.divideBy = Val(sStr)
        'Line Input #cf, sStr

        ' (9 parameters) Configuration file Line 2
        Input(cf, sStr)
        M_203.dacEnable = Val(sStr)
        Input(cf, sStr)
        M_203.baud = Val(sStr)
        Input(cf, sStr)
        M_203.comPort = Val(Mid(sStr, 4, 1)) - 1

        Input(cf, sStr)
        M_203.inputBuffer = Val(sStr)
        If M_203.inputBuffer < 11 Then
            M_203.inputBuffer = 11
        Else
            If M_203.inputBuffer > 32767 Then
                M_203.inputBuffer = 32767
            End If
        End If
        Input(cf, sStr)
        spare = Val(sStr)
        Input(cf, sStr)
        M_203.bU = Val(sStr)
        Input(cf, sStr)
        M_203.gain1 = Val(sStr)
        Input(cf, sStr)
        M_203.maxRate = Val(sStr)
        sStr = LineInput(cf)
        M_203.wL = Val(sStr)

        ' (4 parameters) Configuration file Line 3
        Input(cf, sStr)
        placeholder = Val(sStr)
        Input(cf, sStr)
        placeholder = Val(sStr)
        Input(cf, sStr)
        placeholder = Val(sStr)
        sStr = LineInput(cf)
        placeholder = Val(sStr)

        ' (3 parameters) Configuration file Line 4
        Input(cf, sStr)
        placeholder = Val(sStr)
        Input(cf, sStr)
        placeholder = Val(sStr)
        sStr = LineInput(cf)
        M_203.scanChan = Val(sStr)

        ' (6 parameters) Configuration file Line 5
        Input(cf, sStr)
        M_203.scan = Val(sStr)
        Input(cf, sStr)
        M_203.scan1 = Val(sStr)
        Input(cf, sStr)
        M_203.scan2 = Val(sStr)
        Input(cf, sStr)
        M_203.scanInterval = Val(sStr)
        Input(cf, sStr)
        M_203.tScan = Val(sStr)
        sStr = LineInput(cf)
        reserved = Val(sStr)

        ' (8 parameters) Configuration file Line 6
        Input(cf, sStr)
        M_203.dac1volts = Val(sStr)
        Input(cf, sStr)
        M_203.dac2volts = Val(sStr)
        Input(cf, sStr)
        M_203.totalPeriods = Val(sStr)
        Input(cf, sStr)
        If UCase(sStr) = "TEXT" Then
            scandisp = 0
        Else
            scandisp = 1
        End If
        Input(cf, sStr)
        posfs = Val(sStr)
        Input(cf, sStr)
        negfs = Val(sStr)
        Input(cf, sStr)
        vdiv = Val(sStr)
        sStr = LineInput(cf)
        hdiv = Val(sStr)

        ' (3 parameters) Configuration file Line 7
        Input(cf, sStr)
        M_203.gain = Val(sStr)
        Input(cf, sStr)
        M_203.runningAvg = Val(sStr)
        Input(cf, sStr)
        M_203.timeBase = Val(sStr)
        FileClose(cf)
        GoTo EXIT_READ_CFG

NO_FILE:
        FileClose(cf)
        MsgDisplay(("File error M203.CFG" & Chr(10) & Chr(10) & Chr(10) & "Locate and place configuration file in" & Chr(10) & Chr(10) & "same directory as application and try again." & Chr(10) & Chr(10) & Chr(10) & "Creating a default configuration" & Chr(10) & Chr(10)))

        'Set some default parameters
        scandisp = 0 'Text Scan display mode
        reserved = 0
        placeholder = 0
        M_203.comPort = 0 'COM1
        M_203.scanInterval = 1 '1 sec
        M_203.numChannels = 1 '1 channel
        M_203.tScan = 0 '0 Single Channel Scanning
        M_203.scanChan = 7 '0 Input Channel - Scanning
        M_203.lastDigInp = 255 'All High Last digital input value
        M_203.version = 203 'Model 203 version (203)
        M_203.pollChan = 7 '7 Offset Channel
        M_203.subSample = 160 '60 Hz Value, 192 for 50 Hz
        M_203.rawCount = 0 '0 Last raw count
        M_203.digOutWord = 256 '256 Non-Valid Value - Last value sent (0-255)
        M_203.wordCnt = 3 '3 for 24-bit)
        M_203.errorType = 0 'error code returned from DLL
        M_203.bU = 1 'UniPolar = 0, BiPolar=1 (M203 always BiPolar)
        M_203.filter_Renamed = 0 'Not used
        M_203.divideBy = 0 '0 Remote (power of 2) division (/1)
        M_203.gain1 = 1
        M_203.gain = 1
        M_203.maxRate = 120 'Maximum sample rate (120 Hz for 60Hz)
        M_203.modeRegHi = 0 'Not used
        M_203.modeRegMid = 128 'MSB = 1, (24 bit) word length
        M_203.modeRegLo = 2
        M_203.totalPeriods = 2 '2 for 60 HZ Sample Rate (with 120 maxRate)
        M_203.baud = 0 '0=9600 bps
        M_203.dac1volts = 0 'Current Voltage for Analog Output 1
        M_203.dac2volts = 0 'Current Voltage for Analog Output 2
        M_203.dacEnable = 0 'Not Used
        M_203.timeBase = 96 '256 - SubSample
        M_203.echoTestCount = 0 'Serial Echo Test Byte Count
        M_203.runningAvg = 1
        M_203.dataAcqMode = 1 '1 = Polled
        M_203.wL = 128
        M_203.inputBuffer = 32767
        posfs = 0
        negfs = 0
        vdiv = 0
        hdiv = 0

EXIT_READ_CFG:
        On Error GoTo 0
    End Sub
    Public Sub Wait(ByRef WaitTime As Object)
        Dim dblEndTime As Double
        'UPGRADE_WARNING: Couldn't resolve default property of object WaitTime. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
        dblEndTime = VB.Timer() + WaitTime
        Do While dblEndTime > VB.Timer()
            System.Windows.Forms.Application.DoEvents()
        Loop
    End Sub
    Public Sub MsgDisplay(ByRef Msg As Object)
        Dim retVal As Integer
        'MsgBox Msg, vbOK           'this box has no title control
        'UPGRADE_WARNING: Couldn't resolve default property of object Msg. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
        retVal = MessageBox(0, Msg, "Error ----", 0)
    End Sub
End Module